3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11 or: $dashless [--quiet] init [--] [<path>...]
12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
14 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15 or: $dashless [--quiet] foreach [--recursive] <command>
16 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
17 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
23 wt_prefix=$(git rev-parse --show-prefix)
26 # Tell the rest of git that any URLs we get don't come
27 # directly from the user, so it can apply policy as appropriate.
28 GIT_PROTOCOL_FROM_USER=0
29 export GIT_PROTOCOL_FROM_USER
50 if test "$1" = "#unmatched"
57 # Print a submodule configuration setting
63 # Checks in the usual git-config places first (for overrides),
64 # otherwise it falls back on .gitmodules. This allows you to
65 # distribute project-wide defaults in .gitmodules, while still
66 # customizing individual repositories if necessary. If the option is
67 # not in .gitmodules either, print a default value.
69 get_submodule_config () {
73 value=$(git config submodule."$name"."$option")
76 value=$(git submodule--helper config submodule."$name"."$option")
78 printf '%s' "${value:-$default}"
83 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
86 # Given a full hex object ID, is this the zero OID?
88 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
91 # Sanitize the local git environment for use within a submodule. We
92 # can't simply use clear_local_git_env since we want to preserve some
93 # of the settings from GIT_CONFIG_PARAMETERS.
94 sanitize_submodule_env()
96 save_config=$GIT_CONFIG_PARAMETERS
98 GIT_CONFIG_PARAMETERS=$save_config
99 export GIT_CONFIG_PARAMETERS
103 # Add a new submodule to the working tree, .gitmodules and the index
107 # optional branch is stored in global branch variable
111 # parse $args after "submodule ... add".
117 case "$2" in '') usage ;; esac
131 case "$2" in '') usage ;; esac
136 reference_path="${1#--reference=}"
142 case "$2" in '') usage ;; esac
147 case "$2" in '') usage ;; esac
168 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
170 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
173 if test -n "$reference_path"
175 is_absolute_path "$reference_path" ||
176 reference_path="$wt_prefix$reference_path"
178 reference="--reference=$reference_path"
184 if test -z "$sm_path"; then
185 sm_path=$(printf '%s\n' "$repo" |
186 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
189 if test -z "$repo" || test -z "$sm_path"; then
193 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
195 # assure repo is absolute or relative to parent
198 test -z "$wt_prefix" ||
199 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
201 # dereference source url relative to parent's url
202 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
209 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
214 # multiple //; leading ./; /./; /../; trailing /
215 sm_path=$(printf '%s/\n' "$sm_path" |
227 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
228 die "$(eval_gettext "'\$sm_path' already exists in the index")"
230 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
231 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
234 if test -z "$force" &&
235 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
237 eval_gettextln "The following path is ignored by one of your .gitignore files:
239 Use -f if you really want to add it." >&2
243 if test -n "$custom_name"
245 sm_name="$custom_name"
250 if ! git submodule--helper check-name "$sm_name"
252 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
255 # perhaps the path exists and is already a git repo, else clone it
256 if test -e "$sm_path"
258 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
260 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
262 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
266 if test -d ".git/modules/$sm_name"
270 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
271 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
272 die "$(eval_gettextln "\
273 If you want to reuse this local git directory instead of cloning again from
275 use the '--force' option. If the local git directory is not the correct repo
276 or you are unsure what this means choose another name with the '--name' option.")"
278 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
281 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
283 sanitize_submodule_env
285 # ash fails to wordsplit ${branch:+-b "$branch"...}
287 '') git checkout -f -q ;;
288 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
290 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
292 git config submodule."$sm_name".url "$realrepo"
294 git add --no-warn-embedded-repo $force "$sm_path" ||
295 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
297 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
298 git submodule--helper config submodule."$sm_name".url "$repo" &&
301 git submodule--helper config submodule."$sm_name".branch "$branch"
303 git add --force .gitmodules ||
304 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
306 # NEEDSWORK: In a multi-working-tree world, this needs to be
307 # set in the per-worktree config.
308 if git config --get submodule.active >/dev/null
310 # If the submodule being adding isn't already covered by the
311 # current configured pathspec, set the submodule's active flag
312 if ! git submodule--helper is-active "$sm_path"
314 git config submodule."$sm_name".active "true"
317 git config submodule."$sm_name".active "true"
322 # Execute an arbitrary command sequence in each checked out
325 # $@ = command to execute
329 # parse $args after "submodule ... foreach".
349 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
353 # Register submodules in .git/config
355 # $@ = requested paths (default to all)
359 # parse $args after "submodule ... init".
380 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
384 # Unregister submodules from .git/config and remove their work tree
388 # parse $args after "submodule ... deinit".
416 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
419 is_tip_reachable () (
420 sanitize_submodule_env &&
422 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
426 fetch_in_submodule () (
427 sanitize_submodule_env &&
434 git fetch $(get_default_remote) "$@" ;;
439 # Update each submodule path to correct revision, using clone and checkout as needed
441 # $@ = requested paths (default to all)
445 # parse $args after "submodule ... update".
474 case "$2" in '') usage ;; esac
475 reference="--reference=$2"
494 recommend_shallow="--recommend-shallow"
496 --no-recommend-shallow)
497 recommend_shallow="--no-recommend-shallow"
500 case "$2" in '') usage ;; esac
508 case "$2" in '') usage ;; esac
531 cmd_init "--" "$@" || return
535 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
536 ${progress:+"--progress"} \
537 ${wt_prefix:+--prefix "$wt_prefix"} \
538 ${prefix:+--recursive-prefix "$prefix"} \
539 ${update:+--update "$update"} \
540 ${reference:+"$reference"} \
541 ${dissociate:+"--dissociate"} \
542 ${depth:+--depth "$depth"} \
545 "$@" || echo "#unmatched" $?
548 while read -r quickabort sha1 just_cloned sm_path
550 die_if_unmatched "$quickabort" "$sha1"
552 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
554 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
556 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
558 if test $just_cloned -eq 1
562 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
563 git rev-parse --verify HEAD) ||
564 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
569 branch=$(git submodule--helper remote-branch "$sm_path")
570 if test -z "$nofetch"
572 # Fetch remote before determining tracking $sha1
573 fetch_in_submodule "$sm_path" $depth ||
574 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
576 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
577 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
578 git rev-parse --verify "${remote_name}/${branch}") ||
579 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
582 if test "$subsha1" != "$sha1" || test -n "$force"
585 # If we don't already have a -f flag and the submodule has never been checked out
586 if test -z "$subsha1" && test -z "$force"
591 if test -z "$nofetch"
593 # Run fetch only if $sha1 isn't present or it
594 # is not reachable from a ref.
595 is_tip_reachable "$sm_path" "$sha1" ||
596 fetch_in_submodule "$sm_path" $depth ||
597 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
599 # Now we tried the usual fetch, but $sha1 may
600 # not be reachable from any of the refs
601 is_tip_reachable "$sm_path" "$sha1" ||
602 fetch_in_submodule "$sm_path" $depth "$sha1" ||
603 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
607 case "$update_module" in
609 command="git checkout $subforce -q"
610 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
611 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
615 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
616 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
617 must_die_on_failure=yes
621 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
622 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
623 must_die_on_failure=yes
626 command="${update_module#!}"
627 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
628 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
629 must_die_on_failure=yes
632 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
635 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
638 elif test -n "$must_die_on_failure"
640 die_with_status 2 "$die_msg"
642 err="${err};$die_msg"
647 if test -n "$recursive"
650 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
652 sanitize_submodule_env
659 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
662 err="${err};$die_msg"
665 die_with_status $res "$die_msg"
689 # Show commit summary for submodules in index or working tree
691 # If '--cached' is given, show summary between index and given commit,
692 # or between working tree and given commit
694 # $@ = [commit (default 'HEAD'),] requested paths (default all)
701 # parse $args after "submodule ... summary".
716 isnumber "$summary_limit" || usage
720 summary_limit="${1#--summary-limit=}"
721 isnumber "$summary_limit" || usage
737 test $summary_limit = 0 && return
739 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
743 elif test -z "$1" || test "$1" = "HEAD"
745 # before the first commit: compare with an empty tree
746 head=$(git hash-object -w -t tree --stdin </dev/null)
747 test -z "$1" || shift
755 die "$(gettext "The --cached option cannot be used with the --files option")"
761 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
762 # Get modified modules cared by user
763 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
764 sane_egrep '^:([0-7]* )?160000' |
765 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
767 # Always show modules deleted or type-changed (blob<->module)
768 if test "$status" = D || test "$status" = T
770 printf '%s\n' "$sm_path"
773 # Respect the ignore setting for --for-status.
774 if test -n "$for_status"
776 name=$(git submodule--helper name "$sm_path")
777 ignore_config=$(get_submodule_config "$name" ignore none)
778 test $status != A && test $ignore_config = all && continue
780 # Also show added or modified modules which are checked out
781 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
782 printf '%s\n' "$sm_path"
786 test -z "$modules" && return
788 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
789 sane_egrep '^:([0-7]* )?160000' |
791 while read -r mod_src mod_dst sha1_src sha1_dst status name
793 if test -z "$cached" &&
794 is_zero_oid $sha1_dst
798 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
800 100644 | 100755 | 120000)
801 sha1_dst=$(git hash-object $name)
807 eval_gettextln "unexpected mode \$mod_dst" >&2
814 test $mod_src = 160000 &&
815 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
818 test $mod_dst = 160000 &&
819 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
822 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
825 case "$missing_src,$missing_dst" in
827 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
830 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
833 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
838 if test $mod_src = 160000 && test $mod_dst = 160000
840 range="$sha1_src...$sha1_dst"
841 elif test $mod_src = 160000
847 GIT_DIR="$name/.git" \
848 git rev-list --first-parent $range -- | wc -l
850 total_commits=" ($(($total_commits + 0)))"
854 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
855 echo $sha1_src | cut -c1-7)
856 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
857 echo $sha1_dst | cut -c1-7)
861 blob="$(gettext "blob")"
862 submodule="$(gettext "submodule")"
863 if test $mod_dst = 160000
865 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
867 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
870 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
874 # Don't give error msg for modification whose dst is not submodule
875 # i.e. deleted or changed to blob
876 test $mod_dst = 160000 && echo "$errmsg"
878 if test $mod_src = 160000 && test $mod_dst = 160000
881 test $summary_limit -gt 0 && limit="-$summary_limit"
882 GIT_DIR="$name/.git" \
883 git log $limit --pretty='format: %m %s' \
884 --first-parent $sha1_src...$sha1_dst
885 elif test $mod_dst = 160000
887 GIT_DIR="$name/.git" \
888 git log --pretty='format: > %s' -1 $sha1_dst
890 GIT_DIR="$name/.git" \
891 git log --pretty='format: < %s' -1 $sha1_src
899 # List all submodules, prefixed with:
900 # - submodule not initialized
901 # + different revision checked out
903 # If --cached was specified the revision in the index will be printed
904 # instead of the currently checked out revision.
906 # $@ = requested paths (default to all)
910 # parse $args after "submodule ... status".
937 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
940 # Sync remote urls for submodules
941 # This makes the value for remote.$remote.url match the value
942 # specified in .gitmodules.
970 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
975 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
978 # This loop parses the command line arguments to find the
979 # subcommand name to dispatch. Parsing of the subcommand specific
980 # options are primarily done by the subcommand implementations.
981 # Subcommand specific options such as --branch and --cached are
982 # parsed here as well, for backward compatibility.
984 while test $# != 0 && test -z "$command"
987 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1017 # No command word defaults to "status"
1018 if test -z "$command"
1028 # "-b branch" is accepted only by "add"
1029 if test -n "$branch" && test "$command" != add
1034 # "--cached" is accepted only by "status" and "summary"
1035 if test -n "$cached" && test "$command" != status && test "$command" != summary